Publications
============

The PLanComps approach to component-based specification of programming
languages is based on the ideas and foundations explained in the publications
listed below. *Note:* The notation and funcons presented in previous publications vary
considerably; future publications should be consistent with the final
release of CBS.

- L. T. van Binsbergen, N. Sculthorpe, P. D. Mosses,
  __[Tool support for component-based semantics](http://plancomps.org/modularity2016)__,
  in: *Companion Proceedings of the 15th International Conference on Modularity,*
  ACM, 2016, pp. 8-11.
  [doi:10.1145/2892664.2893464](http://dx.doi.org/10.1145/2892664.2893464)

- N. Sculthorpe, P. Torrini, P. D. Mosses,
  __[A modular structural operational semantics for delimited continuations](http://plancomps.org/WoC2016)__,
  in: *Post-proceedings of the 2015 Workshop on Continuations,*
  Vol. 212 of EPTCS, Open Publishing Association, 2016, pp. 63–80. 
  [doi:10.4204/EPTCS.212.5](https://doi.org/10.4204/EPTCS.212.5)

- M. Churchill, P. D. Mosses, N. Sculthorpe, P. Torrini,
  __[Reusable components of semantic specifications](http://plancomps.org/taosd2015)__,
  in: *Transactions on Aspect-Oriented Software Development XII,*
  Vol. 8989 of LNCS, Springer, 2015, pp. 132–179. 
  [doi:10.1007/978-3-662-46734-3_4](https://doi.org/10.1007/978-3-662-46734-3_4)

- P. D. Mosses, F. Vesely,
  __Weak bisimulation as a congruence in MSOS__,
  in: *Logic, Rewriting, and Concurrency,*
  Vol. 9200 of LNCS, Springer, 2015, pp. 519–538. 
  [doi:10.1007/978-3-319-23165-5_ 24](https://doi.org/10.1007/978-3-319-23165-5_24)

- P. D. Mosses, F. Vesely, 
  __[FunKons: Component-based semantics in K](http://plancomps.org/funkons-component-based-semantics-in-k)__,
  in: *10th International Workshop on Rewriting Logic and Its Applications,*
  Vol. 8663 of LNCS, Springer, 2014, pp. 213–229. 
  [doi:10.1007/978-3-319-12904-4_12](https://doi.org/10.1007/978-3-319-12904-4_12)

- M. Churchill, P. D. Mosses,
  __[Modular bisimulation theory for computations and values](http://plancomps.org/churchill2013a)__,
  in: *16th International Conference on Foundations of Software Science and 
  Computation Structures,*
  Vol. 7794 of LNCS, Springer, 2013, pp. 97–112. 
  [doi:10.1007/ 978-3-642-37075-5_7](https://doi.org/10.1007/978-3-642-37075-5_7)

- A. Johnstone, P. D. Mosses, E. Scott,
  __An agile approach to language modelling and development,__
  *Innovations Syst. Softw. Eng.* 6 (2010) pp. 145–153.
  [doi:10.1007/s11334-009-0111-6](https://doi.org/10.1007/s11334-009-0111-6)

- P. D. Mosses,
  __Component-based semantics__,
  in: *Proceedings of the 8th international Workshop on Specification and 
  Verification of Component-Based Systems,*
  ACM, 2009, pp. 3-10.
  [doi:10.1145/1596486.1596489](https://doi.org/10.1145/1596486.1596489)

- P. D. Mosses, M. J. New,
  __Implicit propagation in structural operational semantics__, 
  *Electr. Notes Theor. Comput. Sci.* 229 (2009) pp. 49-66.
  [doi:10.1016/j.entcs.2009.07.073](https://doi.org/10.1016/j.entcs.2009.07.073)

- P. D. Mosses,
  __Modular language descriptions__,
  in: *Third International Conference on Generative Programming and Component Engineering,*
  Vol. 3286 of LNCS, Springer, 2004, p. 489.
  [doi:10.1007/978-3-540-30175-2_27](https://doi.org/10.1007/978-3-540-30175-2_27)

- P. D. Mosses,
  __Modular structural operational semantics__, 
  *J. Log. Algebr. Program.* 60-61 (2004) pp. 195-228.
  [doi:10.1016/j.jlap.2004.03.008](https://doi.org/10.1016/j.jlap.2004.03.008)
